searchNodes=[{"doc":"A implementation of Jsonpath expression proposal by Stefan Goessner for Elixir. The following apis are available: Warpath.query/3 , Warpath.delete/2 , Warpath.update/3 . Operators Operator Description $ The root element to query. This starts all path expressions. @ The current node being processed by a filter predicate. * Wildcard. All objects/elements regardless their names. .. Deep scan, recursive descent. .name Dot-notated child, it support string or atom as keys. ['name'] , [&quot;name&quot;] Bracket-notated child, it support string or atom as keys. [int (,int&gt;)] Array index or indexes [start:end:step] Array slice operator. Start index inclusive , end index exclusive . [?(expression)] Filter expression. Expression must evaluate to a boolean value. Filter operators All filter operator supported by Warpath have the same behavior of Elixir lang, it means that it's possible to compare different data types, check the Elixir getting started page for more information about cross comparision on data types. Filter are expression that must be result on a boolean value, Warpath will use then to retain data when filter a data structure; a filter expression have it syntax like this [?( @.category == 'fiction' )] . Operator Description == left is equal to right === left is equal to right in strict mode != left is not equal to right !== left is not equal to right in strict mode &lt; left is less than right &lt;= left is less or equal to right &gt; left is greater than right &gt;= left is greater than or equal to right in left exists in right [?(@.price in [10, 20, 30])] and,&amp;&amp; logical and operator [?(@.price &gt; 50 and @.price &lt; 100)] or,|| logical or operator [?(@.category == 'fiction' or @.price &lt; 100)] not logical not operator [?(not @.category == 'fiction')] Functions allowed in filter expression Function Description is_atom/1 check if the given expression argument is evaluate to atom is_binary/1 check if the given expression argument is evaluate to binary is_boolean/1 check if the given expression argument is evaluate to boolean is_float/1 check if the given expression argument is evaluate to float is_integer/1 check if the given expression argument is evaluate to integer is_list/1 check if the given expression argument is evaluate to list is_map/1 check if the given expression argument is evaluate to map is_nil/1 check if the given expression argument is evaluate to nil is_number/1 check if the given expression argument is evaluate to number is_tuple/1 check if the given expression argument is evaluate to tuple Examples All children #wildcard using bracket-notation iex&gt; document = %{ &quot;elements&quot; =&gt; [ :a , :b , :c ] } ...&gt; Warpath . query ( document , &quot;$.elements[*]&quot; ) { :ok , [ :a , :b , :c ] } #wildcard using dot-notation iex&gt; document = %{ &quot;integers&quot; =&gt; [ 100 , 200 , 300 ] } ...&gt; Warpath . query ( document , &quot;$.integers.*&quot; ) { :ok , [ 100 , 200 , 300 ] } Children lookup by name #Simple string iex&gt; Warpath . query ( %{ &quot;category&quot; =&gt; &quot;fiction&quot; , &quot;price&quot; =&gt; 12.99 } , &quot;$.category&quot; ) { :ok , &quot;fiction&quot; } #Quoted string iex&gt; Warpath . query ( %{ &quot;key with whitespace&quot; =&gt; &quot;some value&quot; } , &quot;$.[&#39;key with whitespace&#39;]&quot; ) { :ok , &quot;some value&quot; } #Simple atom iex&gt; Warpath . query ( %{ atom_key : &quot;some value&quot; } , &quot;$.:atom_key&quot; ) { :ok , &quot;some value&quot; } #Quoted atom iex&gt; Warpath . query ( %{ &quot;atom key&quot; : &quot;some value&quot; } , ~S{$.:&#39;atom key&#39;} ) { :ok , &quot;some value&quot; } #Unicode support iex&gt; Warpath . query ( %{ &quot;🌢&quot; =&gt; &quot;Elixir&quot; } , &quot;$.🌢&quot; ) { :ok , &quot;Elixir&quot; } #Union iex&gt; document = %{ &quot;key&quot; =&gt; &quot;value&quot; , &quot;another&quot; =&gt; &quot;entry&quot; } ...&gt; Warpath . query ( document , &quot;$[&#39;key&#39;, &#39;another&#39;]&quot; ) { :ok , [ &quot;value&quot; , &quot;entry&quot; ] } Children lookup by index #Positive index iex&gt; document = %{ &quot;elements&quot; =&gt; [ :a , :b , :c ] } ...&gt; Warpath . query ( document , &quot;$.elements[0]&quot; ) { :ok , :a } #Negative index iex&gt; document = %{ &quot;elements&quot; =&gt; [ :a , :b , :c ] } ...&gt; Warpath . query ( document , &quot;$.elements[-1]&quot; ) { :ok , :c } #Union iex&gt; document = %{ &quot;elements&quot; =&gt; [ :a , :b , :c ] } ...&gt; Warpath . query ( document , &quot;$.elements[0, 1]&quot; ) { :ok , [ :a , :b ] } Slice iex&gt; document = [ 0 , 1 , 2 , 3 , 4 ] ...&gt; Warpath . query ( document , &quot;$[0:2:1]&quot; ) { :ok , [ 0 , 1 ] } #optional start and step param. iex&gt; document = [ 0 , 1 , 2 , 3 , 4 ] ...&gt; Warpath . query ( document , &quot;$[:2]&quot; ) { :ok , [ 0 , 1 ] } #Negative start index iex&gt; document = [ 0 , 1 , 2 , 3 , 4 ] ...&gt; Warpath . query ( document , &quot;$[-2:]&quot; ) { :ok , [ 3 , 4 ] } Filter # Using logical and operator with is_integer function guard to gain strictness iex&gt; document = %{ &quot;store&quot; =&gt; %{ &quot;car&quot; =&gt; %{ &quot;price&quot; =&gt; 100_000 } , &quot;bicycle&quot; =&gt; %{ &quot;price&quot; =&gt; 500 } } } ...&gt; Warpath . query ( document , &quot;$..*[?( @.price &gt; 500 and is_integer(@.price) )]&quot; ) { :ok , [ %{ &quot;price&quot; =&gt; 100_000 } ] } # Deep path matching iex&gt; addresses = [ %{ &quot;address&quot; =&gt; %{ &quot;state&quot; =&gt; &quot;Bahia&quot; } } , %{ &quot;address&quot; =&gt; %{ &quot;state&quot; =&gt; &quot;São Paulo&quot; } } ] ...&gt; Warpath . query ( addresses , &quot;$[?(@.address.state==&#39;Bahia&#39;)]&quot; ) { :ok , [ %{ &quot;address&quot; =&gt; %{ &quot;state&quot; =&gt; &quot;Bahia&quot; } } ] } #has children using named key iex&gt; document = %{ &quot;store&quot; =&gt; %{ &quot;car&quot; =&gt; %{ &quot;price&quot; =&gt; 100_000 } , &quot;bicycle&quot; =&gt; %{ &quot;price&quot; =&gt; 500 } } } ...&gt; Warpath . query ( document , &quot;$..*[?(@.price)]&quot; ) { :ok , [ %{ &quot;price&quot; =&gt; 500 } , %{ &quot;price&quot; =&gt; 100_000 } ] } #has children using index iex&gt; document = [ [ 1 , 2 , 3 ] , [ 0 , 5 ] , [ ] , [ 1 ] , 9 , [ 9 , 8 , 7 ] ] ...&gt; Warpath . query ( document , &quot;$[?( @[2] )]&quot; ) # That means give me all list that have index 2. { :ok , [ [ 1 , 2 , 3 ] , [ 9 , 8 , 7 ] ] } Recursive descendant #Collect key iex&gt; document = %{ &quot;store&quot; =&gt; %{ &quot;car&quot; =&gt; %{ &quot;price&quot; =&gt; 100_000 } , &quot;bicycle&quot; =&gt; %{ &quot;price&quot; =&gt; 500 } } } ...&gt; Warpath . query ( document , &quot;$..price&quot; ) { :ok , [ 500 , 100_000 ] } #Collect index iex&gt; document = [ [ 1 , 2 , 3 ] , [ ] , :item , [ 0 , 5 ] , [ 1 ] , 9 , [ 9 , 8 , 7 ] ] ...&gt; Warpath . query ( document , &quot;$..[2]&quot; ) { :ok , [ :item , 3 , 7 ] } #Using filter criteria to scan iex&gt; document = [ [ 1 , 2 ] , [ ] , :item , 9 , [ 9 , 8 ] , 1.1 , &quot;string&quot; ] ...&gt; Warpath . query ( document , &quot;$..[?( is_list(@) )]&quot; ) { :ok , [ [ 1 , 2 ] , [ ] , [ 9 , 8 ] ] } Options iex&gt; document = %{ &quot;elements&quot; =&gt; [ :a , :b , :c ] } ...&gt; Warpath . query ( document , &quot;$.elements&quot; ) { :ok , [ :a , :b , :c ] } iex&gt; document = %{ &quot;elements&quot; =&gt; [ :a , :b , :c ] } ...&gt; Warpath . query ( document , &quot;$.elements[0, 1]&quot; , result_type : :path ) { :ok , [ &quot;$[&#39;elements&#39;][0]&quot; , &quot;$[&#39;elements&#39;][1]&quot; ] } iex&gt; document = %{ &quot;elements&quot; =&gt; [ :a , :b , :c ] } ...&gt; Warpath . query ( document , &quot;$.elements[0]&quot; , result_type : :path_tokens ) { :ok , [ { :root , &quot;$&quot; } , { :property , &quot;elements&quot; } , { :index_access , 0 } ] } iex&gt; document = %{ &quot;elements&quot; =&gt; [ :a , :b , :c ] } ...&gt; Warpath . query ( document , &quot;$.elements[0, 1]&quot; , result_type : :value_path ) { :ok , [ { :a , &quot;$[&#39;elements&#39;][0]&quot; } , { :b , &quot;$[&#39;elements&#39;][1]&quot; } ] } iex&gt; document = %{ &quot;elements&quot; =&gt; [ :a , :b , :c ] } ...&gt; Warpath . query ( document , &quot;$.elements[0]&quot; , result_type : :value_path_tokens ) { :ok , { :a , [ { :root , &quot;$&quot; } , { :property , &quot;elements&quot; } , { :index_access , 0 } ] } }","ref":"Warpath.html","title":"Warpath","type":"module"},{"doc":"Remove an item(s) from a nested data structure via the given selector . If the selector does not evaluate anything, it returns the data structure unchanged. This function rely on Access behaviour, that means structs must implement that behaviour to got support. Examples iex&gt; users = %{ &quot;john&quot; =&gt; %{ &quot;age&quot; =&gt; 27 , &quot;country&quot; =&gt; &quot;Brasil&quot; } , &quot;meg&quot; =&gt; %{ &quot;age&quot; =&gt; 23 , &quot;country&quot; =&gt; &quot;U.K&quot; } } ...&gt; Warpath . delete ( users , &quot;$..age&quot; ) { :ok , %{ &quot;john&quot; =&gt; %{ &quot;country&quot; =&gt; &quot;Brasil&quot; } , &quot;meg&quot; =&gt; %{ &quot;country&quot; =&gt; &quot;U.K&quot; } } } iex&gt; numbers = %{ &quot;numbers&quot; =&gt; [ 20 , 3 , 50 , 6 , 7 ] } ...&gt; Warpath . delete ( numbers , &quot;$.numbers[?(@ &lt; 10)]&quot; ) { :ok , %{ &quot;numbers&quot; =&gt; [ 20 , 50 ] } } iex&gt; numbers = %{ &quot;numbers&quot; =&gt; [ 20 , 3 , 50 , 6 , 7 ] } ...&gt; Warpath . delete ( numbers , &quot;$&quot; ) { :ok , nil } iex&gt; users = %{ &quot;john&quot; =&gt; %{ &quot;age&quot; =&gt; 27 } , &quot;meg&quot; =&gt; %{ &quot;age&quot; =&gt; 23 } } ...&gt; Warpath . delete ( users , &quot;$..city&quot; ) { :ok , %{ &quot;john&quot; =&gt; %{ &quot;age&quot; =&gt; 27 } , &quot;meg&quot; =&gt; %{ &quot;age&quot; =&gt; 23 } } } # Unchanged","ref":"Warpath.html#delete/2","title":"Warpath.delete/2","type":"function"},{"doc":"The same as query/3, but rise exception if it fail.","ref":"Warpath.html#query!/3","title":"Warpath.query!/3","type":"function"},{"doc":"Query data for the given expression. Example iex&gt; data_structure = %{ &quot;name&quot; =&gt; &quot;Warpath&quot; } ...&gt; Warpath . query ( data_structure , &quot;$.name&quot; ) { :ok , &quot;Warpath&quot; } iex&gt; raw_json = ~s/{&quot;name&quot;: &quot;Warpath&quot;}/ ...&gt; Warpath . query ( raw_json , &quot;$.name&quot; ) { :ok , &quot;Warpath&quot; } iex&gt; #Pass a compiled expression as selector ...&gt; { :ok , expression } = Warpath.Expression . compile ( &quot;$.autobots[0]&quot; ) ...&gt; Warpath . query ( %{ &quot;autobots&quot; =&gt; [ &quot;Optimus Prime&quot; , &quot;Warpath&quot; ] } , expression ) { :ok , &quot;Optimus Prime&quot; } Options: result_type: :value - return the value of evaluated expression - default :path - return the bracketfiy path string representation of evaluated expression instead of it's value :value_path - return both value and bracketify path string. :path_tokens - return the path tokens instead of it string representation, see Warpath.Element.Path . :value_path_tokens - return both value and path tokens.","ref":"Warpath.html#query/3","title":"Warpath.query/3","type":"function"},{"doc":"Updates a nested data structure via the given selector . The fun will be called for each item discovered under the given selector , the fun result will be used to update the data structure. If the selector does not evaluate anything, it returns the data structure unchanged. This function rely on Access behaviour, that means structs must implement that behaviour to got support. Examples iex&gt; users = %{ &quot;john&quot; =&gt; %{ &quot;age&quot; =&gt; 27 } , &quot;meg&quot; =&gt; %{ &quot;age&quot; =&gt; 23 } } ...&gt; Warpath . update ( users , &quot;$.john.age&quot; , &amp; ( &amp;1 + 1 ) ) { :ok , %{ &quot;john&quot; =&gt; %{ &quot;age&quot; =&gt; 28 } , &quot;meg&quot; =&gt; %{ &quot;age&quot; =&gt; 23 } } } iex&gt; numbers = %{ &quot;numbers&quot; =&gt; [ 20 , 3 , 50 , 6 , 7 ] } ...&gt; Warpath . update ( numbers , &quot;$.numbers[?(@ &lt; 10)]&quot; , &amp; ( &amp;1 * 2 ) ) { :ok , %{ &quot;numbers&quot; =&gt; [ 20 , 6 , 50 , 12 , 14 ] } } iex&gt; users = %{ &quot;john&quot; =&gt; %{ &quot;age&quot; =&gt; 27 } , &quot;meg&quot; =&gt; %{ &quot;age&quot; =&gt; 23 } } ...&gt; Warpath . update ( users , &quot;$.theo.age&quot; , &amp; ( &amp;1 + 1 ) ) { :ok , %{ &quot;john&quot; =&gt; %{ &quot;age&quot; =&gt; 27 } , &quot;meg&quot; =&gt; %{ &quot;age&quot; =&gt; 23 } } } # Unchanaged","ref":"Warpath.html#update/3","title":"Warpath.update/3","type":"function"},{"doc":"","ref":"Warpath.html#t:container/0","title":"Warpath.container/0","type":"type"},{"doc":"","ref":"Warpath.html#t:document/0","title":"Warpath.document/0","type":"type"},{"doc":"","ref":"Warpath.html#t:json/0","title":"Warpath.json/0","type":"type"},{"doc":"","ref":"Warpath.html#t:opts/0","title":"Warpath.opts/0","type":"type"},{"doc":"","ref":"Warpath.html#t:selector/0","title":"Warpath.selector/0","type":"type"},{"doc":"","ref":"Warpath.html#t:update_fun/0","title":"Warpath.update_fun/0","type":"type"},{"doc":"","ref":"Warpath.html#t:updated_value/0","title":"Warpath.updated_value/0","type":"type"},{"doc":"This module contains functions to accumulate and transform item path tokens. The path are built during a expression evaluation by Warpath.query/3 .","ref":"Warpath.Element.Path.html","title":"Warpath.Element.Path","type":"module"},{"doc":"Accumulate a path token into a path acc. Example iex&gt; acc = [ { :root , &quot;$&quot; } ] ...&gt; Warpath.Element.Path . accumulate ( { :property , &quot;name&quot; } , acc ) [ { :property , &quot;name&quot; } , { :root , &quot;$&quot; } ]","ref":"Warpath.Element.Path.html#accumulate/2","title":"Warpath.Element.Path.accumulate/2","type":"function"},{"doc":"Transform path tokens into a jsonpath bracket-notation representation. Example iex&gt; acc = [ { :property , &quot;name&quot; } , { :root , &quot;$&quot; } ] ...&gt; Warpath.Element.Path . bracketify ( acc ) &quot;$[&#39;name&#39;]&quot;","ref":"Warpath.Element.Path.html#bracketify/1","title":"Warpath.Element.Path.bracketify/1","type":"function"},{"doc":"Transform path tokens into a jsonpath dot-notation representation. Example iex&gt; acc = [ { :property , &quot;name&quot; } , { :root , &quot;$&quot; } ] ...&gt; Warpath.Element.Path . dotify ( acc ) &quot;$.name&quot;","ref":"Warpath.Element.Path.html#dotify/1","title":"Warpath.Element.Path.dotify/1","type":"function"},{"doc":"","ref":"Warpath.Element.Path.html#t:acc/0","title":"Warpath.Element.Path.acc/0","type":"type"},{"doc":"","ref":"Warpath.Element.Path.html#t:token/0","title":"Warpath.Element.Path.token/0","type":"type"},{"doc":"This module contains functions to compile a jsonpath query string.","ref":"Warpath.Expression.html","title":"Warpath.Expression","type":"module"},{"doc":"Compile a jsonpath string query Example iex&gt; Warpath.Expression . compile ( &quot;$.post.author&quot; ) { :ok , % Warpath.Expression { tokens : [ { :root , &quot;$&quot; } , { :dot , { :property , &quot;post&quot; } } , { :dot , { :property , &quot;author&quot; } } ] } }","ref":"Warpath.Expression.html#compile/1","title":"Warpath.Expression.compile/1","type":"function"},{"doc":"Compiles jsonpath string query to expression. Examples iex&gt; import Warpath.Expression iex&gt; ~q&quot;$.post.author&quot; % Warpath.Expression { tokens : [ { :root , &quot;$&quot; } , { :dot , { :property , &quot;post&quot; } } , { :dot , { :property , &quot;author&quot; } } ] }","ref":"Warpath.Expression.html#sigil_q/2","title":"Warpath.Expression.sigil_q/2","type":"macro"},{"doc":"","ref":"Warpath.Expression.html#t:dot_access/0","title":"Warpath.Expression.dot_access/0","type":"type"},{"doc":"","ref":"Warpath.Expression.html#t:filter/0","title":"Warpath.Expression.filter/0","type":"type"},{"doc":"","ref":"Warpath.Expression.html#t:guard/0","title":"Warpath.Expression.guard/0","type":"type"},{"doc":"","ref":"Warpath.Expression.html#t:has_children/0","title":"Warpath.Expression.has_children/0","type":"type"},{"doc":"","ref":"Warpath.Expression.html#t:indexes/0","title":"Warpath.Expression.indexes/0","type":"type"},{"doc":"","ref":"Warpath.Expression.html#t:operator/0","title":"Warpath.Expression.operator/0","type":"type"},{"doc":"","ref":"Warpath.Expression.html#t:property/0","title":"Warpath.Expression.property/0","type":"type"},{"doc":"","ref":"Warpath.Expression.html#t:root/0","title":"Warpath.Expression.root/0","type":"type"},{"doc":"","ref":"Warpath.Expression.html#t:scan/0","title":"Warpath.Expression.scan/0","type":"type"},{"doc":"","ref":"Warpath.Expression.html#t:slice/0","title":"Warpath.Expression.slice/0","type":"type"},{"doc":"","ref":"Warpath.Expression.html#t:subpath_expression/0","title":"Warpath.Expression.subpath_expression/0","type":"type"},{"doc":"","ref":"Warpath.Expression.html#t:t/0","title":"Warpath.Expression.t/0","type":"type"},{"doc":"","ref":"Warpath.Expression.html#t:token/0","title":"Warpath.Expression.token/0","type":"type"},{"doc":"","ref":"Warpath.Expression.html#t:union_property/0","title":"Warpath.Expression.union_property/0","type":"type"},{"doc":"","ref":"Warpath.Expression.html#t:wildcard/0","title":"Warpath.Expression.wildcard/0","type":"type"},{"doc":"","ref":"Warpath.Expression.ParserError.html","title":"Warpath.Expression.ParserError","type":"exception"},{"doc":"","ref":"Warpath.Expression.TokenizerError.html","title":"Warpath.Expression.TokenizerError","type":"exception"},{"doc":"","ref":"Warpath.ExpressionError.html","title":"Warpath.ExpressionError","type":"exception"},{"doc":"","ref":"Warpath.ExpressionError.html#t:t/0","title":"Warpath.ExpressionError.t/0","type":"type"},{"doc":"","ref":"Warpath.JsonDecodeError.html","title":"Warpath.JsonDecodeError","type":"exception"},{"doc":"","ref":"Warpath.JsonDecodeError.html#from/1","title":"Warpath.JsonDecodeError.from/1","type":"function"},{"doc":"","ref":"Warpath.JsonDecodeError.html#t:t/0","title":"Warpath.JsonDecodeError.t/0","type":"type"}]